require 'mailer'
# a class that extends Mailer model class
# to differenciate its header and footer from Mailer model class
class SitewideNewsMailer < Mailer
  # to override views/layouts/mailer.*.erb
  layout "sitewide_news_mailer"
  # modified method of super.news_added
  def news_added_sitewide(user, news)
    redmine_headers "Project" => news.project.identifier
    @author = news.author
    message_id news
    references news
    @news = news
    @user = user
    @news_url = url_for(:controller => "news", :action => "show", :id => news)
    mail :to => user,
      :subject => "[#{news.project.name}] #{l(:label_news)}: #{news.title}"
  end
  # modified method of super.deliver_news_added. called from patched News model.
  def self.deliver_news_added_sitewide(news)
    delay = 0
    users = User.where(:status => "1", :type => "User")
    users.each do |user|
      delay += 0.5
      news_added_sitewide(user, news).deliver_later(:wait => delay.second)
    end
  end
end
